package core.notevault.data.sync;

import androidx.room.Entity;
import androidx.room.Ignore;
import androidx.room.PrimaryKey;
import androidx.room.TypeConverters;

@Entity(tableName = "sync_data_objects")
@TypeConverters(SyncDataObjectTypeConverter.class)
public class SyncDataObject {
    @PrimaryKey(autoGenerate = true)
    private int id;

    private String serverID;
    private SyncDataObjectType type;

    @Ignore
    public SyncDataObject(String serverID, SyncDataObjectType type) {
        this.serverID = serverID;
        this.type = type;
    }

    public SyncDataObject() {
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getServerID() {
        return serverID;
    }

    public void setServerID(String serverID) {
        this.serverID = serverID;
    }

    public SyncDataObjectType getType() {
        return type;
    }

    public void setType(SyncDataObjectType type) {
        this.type = type;
    }
}
