package core.notevault.sync.synchronisation;


import core.notevault.sync.synchronisation.songs.creation.SongCreationBatchRequest;
import core.notevault.sync.synchronisation.songs.creation.SongCreationBatchResponse;
import core.notevault.sync.synchronisation.songs.deletion.SongDeletionBatchRequest;
import core.notevault.sync.synchronisation.songs.deletion.SongDeletionBatchResponse;
import core.notevault.sync.synchronisation.songs.modification.SongModificationBatchRequest;
import core.notevault.sync.synchronisation.songs.modification.SongModificationBatchResponse;
import core.notevault.sync.synchronisation.songs.notesheets.UploadResponse;
import okhttp3.MultipartBody;
import okhttp3.RequestBody;
import retrofit2.Call;
import retrofit2.http.*;

import java.time.LocalDateTime;

public interface SyncService {

    @POST("/sync/songs/create")
    Call<SongCreationBatchResponse> performSongCreation(@Body SongCreationBatchRequest syncRequest);

    @POST("/sync/songs/modify")
    Call<SongModificationBatchResponse> performSongModification(@Body SongModificationBatchRequest syncRequest);

    @POST("/sync/songs/delete")
    Call<SongDeletionBatchResponse> performSongDeletion(@Body SongDeletionBatchRequest syncRequest);

    @Multipart
    @POST("/sync/songs/note_sheet/upload")
    Call<UploadResponse> uploadNoteSheet(@Part("serverID") RequestBody serverID, @Part("fileName") RequestBody fileName,
                                         @Part MultipartBody.Part image);

    @GET("/sync/songs/fetch")
    Call<FetchResponse> fetchModifiedSongs(@Query("last_client_sync") LocalDateTime last_client_sync);
}
